package teachingjava;

import java.lang.String; //equivalent to #include in C

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class HelloWorld_with_Exceptions {
  public HelloWorld_with_Exceptions(){

  }

  protected void saySomething(String toSay) throws notSayingHelloException{
    if (toSay == "Hello World") {
      System.out.println(toSay);
    }
    else throw new notSayingHelloException ("Exception in saySomething.");
  }

  public static void main(String[] args) {
    //This is the equivalent of
    // void main (ing argc, char ** argv) in C

    HelloWorld_with_Exceptions us = new HelloWorld_with_Exceptions();
    try{
      us.saySomething("uh");
    }
    catch (notSayingHelloException e) {
      System.err.println(e.getLocalizedMessage());
      e.printStackTrace();
    }

    finally { //The finally segment is executed after the try or after the catch
      //so, we have to try again
      try{
        us.saySomething("Hello World");
      }
      catch (notSayingHelloException e) { //and we catch again
        System.err.println(e.getLocalizedMessage());
        e.printStackTrace();
      }

    }
  }
}