package teachingjava;

import java.lang.String; //this is the equivalent of #include in C

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class notSayingHelloException extends Exception{
  protected final String prependMessage = "Not Saying Hello :-( "; //this is a constant

  public notSayingHelloException(){
    super ();
  }

  public notSayingHelloException(String message){
    //Why the following doesn't work?
//    super(prependMessage + message); //concatenate messages

    //The answer is simple: prependMessage doesn't exist before the base constructor is set
    //as such, we can't have the prepend in the case of this class
    super(message);

  }

  //or can't we?
  // we are overriding the base class' getLocalizedMessage function
  // this function was meant to be overriden
  public String getLocalizedMessage(){
    return prependMessage + this.getMessage();
  }
}